﻿using NetworkResurrector.Agent.Application.Services.Abstractions;
using System;
using System.Diagnostics;
using System.Text;

namespace NetworkResurrector.Agent.Application.Services.Windows
{
    internal class CmdService : ICliService
    {
        public CmdService()
        {
        }

        public (bool success, string message) Execute(string command)
        {
            var msg = new StringBuilder();
            var commandOutput = new StringBuilder();
            var commandError = new StringBuilder();

            var process = new Process();
            process.StartInfo.RedirectStandardError = true;
            process.StartInfo.RedirectStandardOutput = true;
            process.StartInfo.RedirectStandardInput = true;
            process.StartInfo.CreateNoWindow = true;
            process.StartInfo.UseShellExecute = false;
            process.StartInfo.FileName = "cmd.exe";

            commandOutput.Clear();
            commandError.Clear();

            process.OutputDataReceived += new DataReceivedEventHandler(
                (s, e) =>
                {
                    if (!string.IsNullOrEmpty(e.Data))
                        commandOutput.Append(e.Data + "\n");
                });
            process.ErrorDataReceived += new DataReceivedEventHandler(
                (s, e) =>
                {
                    if (!string.IsNullOrEmpty(e.Data))
                        commandError.Append(e.Data + "\n");
                });

            msg.Append($"\nProcess started at: {DateTime.Now}\n");
            process.Start();
            process.StandardInput.WriteLine(command);
            process.StandardInput.Flush();
            process.StandardInput.Close();

            process.BeginOutputReadLine();
            process.BeginErrorReadLine();

            process.WaitForExit();
            msg.Append($"Output:\n {commandOutput}\n");
            msg.Append($"Errors:\n {commandError}\n");
            msg.Append($"Process ended at: {DateTime.Now}");

            return (commandError.Length > 0, msg.ToString());
        }
    }
}
